'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var jsxRuntime = require('react/jsx-runtime');
var icon = require('@arterial/icon');
var list = require('@arterial/list');
var menuSurface = require('@arterial/menu-surface');
var notchedOutline = require('@arterial/notched-outline');
var classNames = require('classnames');
var PropTypes = require('prop-types');
var react = require('react');
var uuid = require('uuid');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var classNames__default = /*#__PURE__*/_interopDefaultLegacy(classNames);
var PropTypes__default = /*#__PURE__*/_interopDefaultLegacy(PropTypes);

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function SelectHelperText(_ref) {
  var className = _ref.className,
      id = _ref.id,
      text = _ref.text,
      validationMsg = _ref.validationMsg,
      validationMsgPersistent = _ref.validationMsgPersistent,
      otherProps = _objectWithoutProperties(_ref, ["className", "id", "text", "validationMsg", "validationMsgPersistent"]);

  var classes = classNames__default['default']('mdc-select-helper-text', className, {
    'mdc-select-helper-text--validation-msg': validationMsg,
    'mdc-select-helper-text--validation-msg-persistent': validationMsgPersistent
  });
  return /*#__PURE__*/jsxRuntime.jsx("p", _objectSpread2(_objectSpread2({
    className: classes,
    "aria-hidden": "true",
    id: id
  }, otherProps), {}, {
    children: text
  }));
}
SelectHelperText.displayName = 'SelectHelperText';
SelectHelperText.propTypes = {
  className: PropTypes__default['default'].string,
  id: PropTypes__default['default'].string,
  persistent: PropTypes__default['default'].bool,
  text: PropTypes__default['default'].node,
  validationMsg: PropTypes__default['default'].bool
};

function SelectHelperLine(_ref) {
  var text = _ref.text;

  if (typeof text === 'object') {
    if (text === null || /*#__PURE__*/react.isValidElement(text)) {
      return text;
    }

    return /*#__PURE__*/jsxRuntime.jsx(SelectHelperText, _objectSpread2({}, text));
  }

  return null;
}
SelectHelperLine.displayName = 'SelectHelperLine';
SelectHelperLine.propTypes = {
  text: PropTypes__default['default'].oneOfType([PropTypes__default['default'].node, PropTypes__default['default'].object])
};

function Select(_ref) {
  var children = _ref.children,
      className = _ref.className,
      disabled = _ref.disabled,
      helperText = _ref.helperText,
      icon$1 = _ref.icon,
      id = _ref.id,
      invalid = _ref.invalid,
      label = _ref.label,
      labelFloating = _ref.labelFloating,
      menuTwoLine = _ref.menuTwoLine,
      menuWidth = _ref.menuWidth,
      onSelect = _ref.onSelect,
      options = _ref.options,
      outlined = _ref.outlined,
      placeholder = _ref.placeholder,
      required = _ref.required,
      style = _ref.style,
      trailingIcon = _ref.trailingIcon,
      value = _ref.value,
      otherProps = _objectWithoutProperties(_ref, ["children", "className", "disabled", "helperText", "icon", "id", "invalid", "label", "labelFloating", "menuTwoLine", "menuWidth", "onSelect", "options", "outlined", "placeholder", "required", "style", "trailingIcon", "value"]);

  var _useState = react.useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      isActivated = _useState2[0],
      setIsActivated = _useState2[1];

  var _useState3 = react.useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      isFocused = _useState4[0],
      setIsFocused = _useState4[1];

  var _useState5 = react.useState(0),
      _useState6 = _slicedToArray(_useState5, 2),
      focusedIndex = _useState6[0],
      setFocusedIndex = _useState6[1];

  var _useState7 = react.useState(-1),
      _useState8 = _slicedToArray(_useState7, 2),
      selectedIndex = _useState8[0],
      setSelectedIndex = _useState8[1];

  var anchorRef = react.useRef();
  var arterialRef = react.useRef(uuid.v4());
  var listItems = react.useRef(new Map());
  var classes = classNames__default['default']('mdc-select', className, {
    'mdc-select--activated': isActivated,
    'mdc-select--disabled': disabled,
    'mdc-select--invalid': invalid,
    'mdc-select--filled': !outlined,
    'mdc-select--focused': isFocused,
    'mdc-select--no-label': !label,
    'mdc-select--outlined': outlined,
    'mdc-select--required': required,
    'mdc-select--with-leading-icon': icon$1
  });
  var isLabelFloating = Boolean(labelFloating || isFocused || value);
  var labelClasses = classNames__default['default']('mdc-floating-label', {
    'mdc-floating-label--float-above': isLabelFloating
  });
  var lineRippleClasses = classNames__default['default']('mdc-line-ripple', {
    'mdc-line-ripple--active': isFocused
  });
  var menuClasses = classNames__default['default']('mdc-select__menu', 'mdc-menu', {
    'mdc-select__menu--invalid': invalid
  });
  var labelId = "".concat(id, "-label");

  function focusListItem(index) {
    var i = index;

    if (!options[i] || options[i].disabled) {
      var next = options.slice(i + 1);
      i = next.findIndex(function (option) {
        return !option.disabled;
      });

      if (i === -1) {
        var previous = options.slice(0, i);
        i = previous.findIndex(function (option) {
          return !option.disabled;
        });
      }
    }

    if (i >= 0 && i < options.length) {
      setTimeout(function () {
        return listItems.current.get(i).focus();
      }, 1);
    }
  }

  function getListItemTabIndex(index) {
    if (options[index].disabled) return;
    return index === focusedIndex ? 0 : -1;
  }

  function getMenuStyle() {
    if (anchorRef.current) {
      var width = menuWidth || anchorRef.current.clientWidth;
      return {
        maxWidth: width,
        width: width
      };
    }
  }

  function getNextIndex(index) {
    var nextIndex = index + 1;
    var option = options[nextIndex];
    if (!option) return index;
    return option.disabled ? getNextIndex(nextIndex) : nextIndex;
  }

  function getPreviousIndex(index) {
    var previousIndex = index - 1;
    var option = options[previousIndex];
    if (!option) return index;
    return option.disabled ? getPreviousIndex(previousIndex) : previousIndex;
  }

  function getText(index) {
    var option = options[index] || {};
    return option.selectedText || option.text || '';
  }

  function handleClick(e) {
    if (disabled) return;

    if (isActivated) {
      setIsActivated(false);
      setIsFocused(true);
    } else {
      focusListItem(selectedIndex);
      setIsActivated(true);
      setIsFocused(true);
    }

    e.preventDefault();
  }

  function handleFocus() {
    setIsFocused(true);
  }

  function handleKeyDown(e) {
    var isEnter = e.key === 'Enter' || e.keyCode === 13;
    var isSpace = e.key === 'Space' || e.keyCode === 32;
    var arrowUp = e.key === 'ArrowUp' || e.keyCode === 38;
    var arrowDown = e.key === 'ArrowDown' || e.keyCode === 40;
    var isTab = e.key === 'Tab' || e.keyCode === 9;

    if (isEnter || isSpace || arrowUp || arrowDown) {
      e.preventDefault();
      focusListItem(selectedIndex);
      setIsActivated(true);
    } else if (isTab) {
      setIsActivated(false);
      setIsFocused(false);
    }
  }

  function handleListItemAction(e, option, index) {
    var isClick = e.type === 'click';
    var isEnter = e.key === 'Enter' || e.keyCode === 13;
    var isSpace = e.key === 'Space' || e.keyCode === 32;
    var arrowUp = e.key === 'ArrowUp' || e.keyCode === 38;
    var arrowDown = e.key === 'ArrowDown' || e.keyCode === 40;
    var isTab = e.key === 'Tab' || e.keyCode === 9;

    if (!option.disabled && (isClick || isEnter || isSpace)) {
      e.preventDefault();
      setTimeout(function () {
        return anchorRef.current.focus();
      }, 0);
      setIsActivated(false);
      if (onSelect) onSelect(option);
    } else if (isTab && e.shiftKey) {
      e.preventDefault();
      setTimeout(function () {
        return anchorRef.current.focus();
      }, 0);
    } else if (arrowUp) {
      e.preventDefault();
      var i = getPreviousIndex(index);
      focusListItem(i);
      setFocusedIndex(i);
    } else if (arrowDown) {
      e.preventDefault();

      var _i = getNextIndex(index);

      focusListItem(_i);
      setFocusedIndex(_i);
    }
  }

  react.useEffect(function () {
    function handleBodyClick(e) {
      var arterial = e.target.dataset.arterial;

      if (!arterial || arterial !== arterialRef.current) {
        setIsActivated(false);
        setIsFocused(false);
      }
    }

    function handleWindowKeyDown(e) {
      var arterial = e.target.dataset.arterial;
      var isEscape = e.key === 'Escape' || e.keyCode === 27;
      var isTab = e.key === 'Tab' || e.keyCode === 9;

      if ((isEscape || isTab) && arterial === arterialRef.current) {
        if (isTab && !e.shiftKey) anchorRef.current.focus();
        setIsActivated(false);
        setIsFocused(false);
      }
    }

    document.body.addEventListener('click', handleBodyClick);
    window.addEventListener('keydown', handleWindowKeyDown);
    return function () {
      document.body.removeEventListener('click', handleBodyClick);
      window.removeEventListener('keydown', handleWindowKeyDown);
    };
  }, []);
  react.useEffect(function () {
    if (value != null) {
      var index = options.findIndex(function (option) {
        return option.value === value;
      });
      setSelectedIndex(index);
    }
  }, [options, value]);
  return /*#__PURE__*/jsxRuntime.jsxs(jsxRuntime.Fragment, {
    children: [/*#__PURE__*/jsxRuntime.jsxs("div", {
      className: classes,
      style: style,
      children: [/*#__PURE__*/jsxRuntime.jsxs("div", _objectSpread2(_objectSpread2(_objectSpread2({}, otherProps), {}, {
        className: "mdc-select__anchor",
        role: "button",
        "aria-haspopup": "listbox",
        "aria-expanded": "false"
      }, label && {
        'aria-labelledby': "".concat(labelId, " ").concat(id)
      }), {}, {
        "data-arterial": arterialRef.current,
        onClick: handleClick,
        onFocus: handleFocus,
        onKeyDown: handleKeyDown,
        ref: anchorRef,
        tabIndex: disabled ? null : 0,
        title: getText(selectedIndex),
        children: [outlined && /*#__PURE__*/jsxRuntime.jsx(notchedOutline.NotchedOutline, {
          "data-arterial": arterialRef.current,
          label: label,
          labelId: labelId,
          notched: isLabelFloating
        }), !outlined && /*#__PURE__*/jsxRuntime.jsx("span", {
          className: "mdc-select__ripple",
          "data-arterial": arterialRef.current
        }), !outlined && label && /*#__PURE__*/jsxRuntime.jsx("span", {
          className: labelClasses,
          "data-arterial": arterialRef.current,
          id: labelId,
          children: label
        }), icon$1 && /*#__PURE__*/jsxRuntime.jsx(icon.Icon, {
          className: "mdc-select__icon",
          "data-arterial": arterialRef.current,
          icon: icon$1
        }), /*#__PURE__*/jsxRuntime.jsx("span", {
          className: "mdc-select__selected-text-container",
          "data-arterial": arterialRef.current,
          children: /*#__PURE__*/jsxRuntime.jsx("span", {
            className: "mdc-select__selected-text",
            "data-arterial": arterialRef.current,
            id: id,
            children: getText(selectedIndex) || placeholder
          })
        }), trailingIcon ? /*#__PURE__*/jsxRuntime.jsx(icon.Icon, {
          className: "mdc-select__dropdown-icon",
          "data-arterial": arterialRef.current,
          icon: trailingIcon
        }) : /*#__PURE__*/jsxRuntime.jsx("span", {
          className: "mdc-select__dropdown-icon",
          "data-arterial": arterialRef.current,
          children: /*#__PURE__*/jsxRuntime.jsxs("svg", {
            className: "mdc-select__dropdown-icon-graphic",
            "data-arterial": arterialRef.current,
            focusable: "false",
            viewBox: "7 10 10 5",
            children: [/*#__PURE__*/jsxRuntime.jsx("polygon", {
              className: "mdc-select__dropdown-icon-inactive",
              "data-arterial": arterialRef.current,
              fillRule: "evenodd",
              points: "7 10 12 15 17 10",
              stroke: "none"
            }), /*#__PURE__*/jsxRuntime.jsx("polygon", {
              className: "mdc-select__dropdown-icon-active",
              "data-arterial": arterialRef.current,
              points: "7 15 12 10 17 15",
              fillRule: "evenodd",
              stroke: "none"
            })]
          })
        }), !outlined && /*#__PURE__*/jsxRuntime.jsx("span", {
          className: lineRippleClasses,
          "data-arterial": arterialRef.current
        })]
      })), /*#__PURE__*/jsxRuntime.jsx(menuSurface.MenuSurface, {
        className: menuClasses,
        anchorCorner: menuSurface.Corner.BOTTOM_LEFT,
        anchorRef: anchorRef,
        "data-arterial": arterialRef.current,
        id: "".concat(id, "-menu"),
        open: isActivated,
        style: getMenuStyle(),
        children: /*#__PURE__*/jsxRuntime.jsx(list.List, {
          "data-arterial": arterialRef.current,
          id: "".concat(id, "-list"),
          role: "listbox",
          twoLine: menuTwoLine,
          children: Array.isArray(options) && options.length > 0 && options.map(function (option, index) {
            return /*#__PURE__*/jsxRuntime.jsxs(list.ListItem, {
              "aria-selected": index === selectedIndex && !option.disabled,
              "data-arterial": arterialRef.current,
              "data-value": option.value,
              disabled: option.disabled,
              id: "".concat(id, "-list-item-").concat(option.value),
              onClick: function onClick(e) {
                return handleListItemAction(e, option, index);
              },
              onKeyDown: function onKeyDown(e) {
                return handleListItemAction(e, option, index);
              },
              ref: function ref(element) {
                return listItems.current.set(index, element);
              },
              role: "option",
              selected: index === selectedIndex && !option.disabled,
              tabIndex: getListItemTabIndex(index),
              children: [option.graphic && /*#__PURE__*/jsxRuntime.jsx(list.ListItemGraphic, {
                "data-arterial": arterialRef.current,
                graphic: option.graphic
              }), menuTwoLine ? /*#__PURE__*/jsxRuntime.jsxs(list.ListItemText, {
                "data-arterial": arterialRef.current,
                children: [/*#__PURE__*/jsxRuntime.jsx(list.ListItemPrimaryText, {
                  "data-arterial": arterialRef.current,
                  title: option.text,
                  children: option.text
                }), /*#__PURE__*/jsxRuntime.jsx(list.ListItemSecondaryText, {
                  "data-arterial": arterialRef.current,
                  title: option.secondaryText,
                  children: option.secondaryText
                }), ")"]
              }) : /*#__PURE__*/jsxRuntime.jsx(list.ListItemText, {
                "data-arterial": arterialRef.current,
                title: getText(index),
                children: option.text
              }), option.node, option.meta && /*#__PURE__*/jsxRuntime.jsx(list.ListItemMeta, {
                "data-arterial": arterialRef.current,
                meta: option.meta
              })]
            }, option.value);
          })
        })
      })]
    }), /*#__PURE__*/jsxRuntime.jsx(SelectHelperLine, {
      "data-arterial": arterialRef.current,
      text: helperText
    })]
  });
}
Select.displayName = 'Select';
Select.propTypes = {
  children: PropTypes__default['default'].node,
  className: PropTypes__default['default'].string,
  disabled: PropTypes__default['default'].bool,
  helperText: PropTypes__default['default'].node,
  icon: PropTypes__default['default'].node,
  id: PropTypes__default['default'].string,
  invalid: PropTypes__default['default'].bool,
  label: PropTypes__default['default'].node,
  labelFloating: PropTypes__default['default'].bool,
  menuWidth: PropTypes__default['default'].string,
  onSelect: PropTypes__default['default'].func,
  options: PropTypes__default['default'].arrayOf(PropTypes__default['default'].shape({
    disabled: PropTypes__default['default'].bool,
    graphic: PropTypes__default['default'].node,
    meta: PropTypes__default['default'].node,
    node: PropTypes__default['default'].node,
    secondaryText: PropTypes__default['default'].string,
    selectedText: PropTypes__default['default'].string,
    text: PropTypes__default['default'].string.isRequired,
    value: PropTypes__default['default'].string.isRequired
  })),
  outlined: PropTypes__default['default'].bool,
  placeholder: PropTypes__default['default'].string,
  required: PropTypes__default['default'].bool,
  style: PropTypes__default['default'].object,
  trailingIcon: PropTypes__default['default'].node,
  twoLine: PropTypes__default['default'].bool,
  value: PropTypes__default['default'].string
};

exports.Select = Select;
exports.SelectHelperText = SelectHelperText;
